freebsd-dev/usr.sbin/bsdconfig/share/media/floppy.subr
Devin Teske 7323adac99 Import media selection/preparation framework (sysinstall inspired). Makes
accessing files from various types of media nice and abstracted away from
the wet-work involved in preparing, validating, and initializing those
types of media. This will be used for the package management system module
and other modules that need access to files and want to allow the user to
decide where those files come from (either in a scripted fashion, prompted
fashion, or any combination thereof).

Heavily inspired by sysinstall and even uses the same reserved words so
that scripts are portable. Coded over months, tested continuously through-
out, and reviewed several times.

Some notes about the changes:
- Move network-setting acquisition/validation routines to media/tcpip.subr
- The options screen from sysinstall has been converted to a dialog menu
- The "UFS" media choice is renamed to "Directory" to reflect how sysinstall
  treats the choice and a new [true] "UFS" media choice has been added that
  acts on real UFS partitions (such as external disks with disklabels).
- Many more help files have been resurrected from sysinstall (I noticed that
  some of the content seems a bit dated; I gave them a once-over but they
  could really use an update).
- A total of 10 media choices are presented (via mediaGetType) including:
  CD/DVD, FTP, FTP Passive, HTTP Proxy, Directory, NFS, DOS, UFS, Floppy, USB
- Novel struct/device management layer for managing the issue of passing
  more information than can comfortably fit in an argument list.
2013-02-25 19:55:32 +00:00

215 lines
6.1 KiB
Plaintext

if [ ! "$_MEDIA_FLOPPY_SUBR" ]; then _MEDIA_FLOPPY_SUBR=1
#
# Copyright (c) 2012-2013 Devin Teske
# All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD$
#
############################################################ INCLUDES
BSDCFG_SHARE="/usr/share/bsdconfig"
. $BSDCFG_SHARE/common.subr || exit 1
f_dprintf "%s: loading includes..." media/floppy.subr
f_include $BSDCFG_SHARE/struct.subr
f_include $BSDCFG_SHARE/device.subr
f_include $BSDCFG_SHARE/dialog.subr
f_include $BSDCFG_SHARE/variable.subr
f_include $BSDCFG_SHARE/media/common.subr
BSDCFG_LIBE="/usr/libexec/bsdconfig"
f_include_lang $BSDCFG_LIBE/include/messages.subr
############################################################ GLOBALS
FLOPPY_MOUNTED=
FLOPPY_DISTWANTED=
############################################################ FUNCTIONS
# f_media_set_floppy
#
# Return success if we both found and set the media type to be a floppy.
#
f_media_set_floppy()
{
f_media_close
local devs ndevs
f_device_find "" $DEVICE_TYPE_FLOPPY devs
ndevs=$( set -- $devs; echo $# )
if [ ${ndevs:=0} -eq 0 ]; then
f_interactive && f_dialog_msgbox "$msg_no_floppy_devices_found"
return $FAILURE
elif [ $ndevs -gt 1 ]; then
local title="$msg_choose_a_floppy_drive"
local prompt="$msg_please_select_a_floppy_drive"
local hline=""
local dev retval
dev=$( f_device_menu \
"$title" "$prompt" "$hline" $DEVICE_TYPE_FLOPPY \
2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD )
retval=$?
[ "$dev" ] || return $FAILURE
f_device_find "$dev" $DEVICE_TYPE_FLOPPY devs
[ "$devs" ] || return $FAILURE
dev="${devs%%[$IFS]*}"
f_struct_copy device_$dev device_media
[ $retval -eq $SUCCESS ] || return $FAILURE
else
f_struct_copy device_$devs device_media
fi
f_struct device_media &&
device_media unset private
f_struct device_media || return $FAILURE
}
# f_media_init_floppy $device
#
# Initializes the Floppy media device. Returns success if able to mount the
# Floppy disk device using either mount_msdosfs(8) or mount(8) (tried in that
# order).
#
f_media_init_floppy()
{
local dev="$1" devname err
device_$dev get devname devname || return $FAILURE
f_dprintf "Init floppy called for %s distribution. devname=[%s]" \
"${FLOPPY_DISTWANTED:-some}" "$devname"
if [ "$FLOPPY_MOUNTED" ]; then
f_dprintf "Floppy device already mounted."
return $SUCCESS
fi
local mp
device_$dev get private mp
if [ ! -e "${mp:=$MOUNTPOINT}" ] && ! f_quietly mkdir -p "$mp"; then
f_show_msg "$msg_unable_to_make_directory_mountpoint" \
"$mp" "$devname"
return $FAILURE
fi
if f_interactive; then
local desc
device_$dev get desc desc
if [ "$FLOPPY_DISTWANTED" ]; then
f_show_msg "$msg_please_insert_floppy_in_drive" "$desc"
else
f_show_msg "$msg_please_insert_floppy_containing" \
"$FLOPPY_DISTWANTED" "$desc"
fi
fi
if ! {
f_quietly mount_msdosfs -o ro -m 0777 -u 0 -g 0 "$devname" "$mp" ||
err=$( mount -o ro "$devname" "$mp" 2>&1 )
}; then
err="${err#mount: }"; err="${err#*: }"
local name
device_$dev get name name
f_show_msg "$msg_error_mounting_floppy_device" \
"$name" "$devname" "$mp" "$err"
return $FAILURE
fi
FLOPPY_MOUNTED=1
FLOPPY_DISTWANTED=
return $SUCCESS
}
# f_media_get_floppy $device $file [$probe_only]
#
# Returns data from $file on a mounted Floppy disk device. Similar to cat(1).
# If $probe_only is present and non-null, limits retries to zero.
#
f_media_get_floppy()
{
local dev="$1" file="$2" probe_only="$3"
f_dprintf "f_media_get_floppy: dev=[%s] file=[%s] probe_only=%s" \
"$dev" "$file" "$probe_only"
#
# floppies don't use f_media_generic_get() because it's too expensive
# to speculatively open files on a floppy disk. Make user get it
# right or give up with floppies.
#
local mp
device_$dev get private mp
local fp="${mp:=$MOUNTPOINT}/$file"
if ! [ -f "$fp" -a -r "$fp" ]; then
local nretries=4
[ "$probe_only" ] && return $FAILURE
while ! [ -f "$fp" -a -r "$fp" ]; do
if [ $nretries -eq 0 ]; then
f_show_msg "$msg_failed_to_get_floppy_file" \
"$fp"
return $FAILURE
fi
FLOPPY_DISTWANTED="$fp"
f_media_shutdown_floppy "$dev"
f_media_init_floppy "$dev" || return $FAILURE
nretries=$(( $nretries - 1 ))
done
fi
cat "$fp"
}
# f_media_shutdown_floppy $device
#
# Shuts down the Floppy disk device using umount(8). Return status should be
# ignored.
#
f_media_shutdown_floppy()
{
local dev="$1" err mp
[ "$FLOPPY_MOUNTED" ] || return
device_$dev get private mp
if ! err=$( umount -f "${mp:=$MOUNTPOINT}" 2>&1 ); then
err="${err#umount: }"; err="${err#*:}"
f_dprintf "Umount of floppy on %s failed: %s" "$mp" "$err"
else
FLOPPY_MOUNTED=
if f_interactive && [ "$_systemState" != "fixit" ]; then
local desc
device_$dev get desc desc
f_show_msg "$msg_you_may_remove_the_floppy" "$desc"
fi
fi
}
############################################################ MAIN
f_dprintf "%s: Successfully loaded." media/floppy.subr
fi # ! $_MEDIA_FLOPPY_SUBR